/* Sniffer example.
   This example code is in the Public Domain (or CC0 licensed, at your option.)

   Unless required by applicable law or agreed to in writing, this
   software is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
   CONDITIONS OF ANY KIND, either express or implied.

   partial source www.ardisoft.com (http://www.ardisoft.com)
   modifié par xav yéyé tranquille version 2

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
//#include "esp_netif.h"
#include "esp_console.h"
#include "esp_event.h"
#include "esp_wifi.h"
#include "esp_err.h"
#include "esp_log.h"
#include "driver/uart.h"
#include "nvs_flash.h"
#include "sdkconfig.h"
#include <byteswap.h>

#include <WiFi.h>
#include <WebServer.h>
//#include <esp_event_loop.h>

#include <BLEDevice.h>
#include <BLEUtils.h>
#include <BLEServer.h>

#define SERVICE_UUID        "4fafc201-1fb5-459e-8fcc-c5c9c331914b"
#define CHARACTERISTIC_UUID "beb5483e-36e1-4688-b7f5-ea07361b26a8"

BLEServer *pServer = NULL;
bool deviceConnected = false;
class MyServerCallbacks: public BLEServerCallbacks 
{
    void onConnect(BLEServer* pServer) 
    {
      deviceConnected = true;
      //Serial.println("BT connecté");
    };

    void onDisconnect(BLEServer* pServer) 
    {
      deviceConnected = false;
      BLEDevice::startAdvertising();
      //Serial.println("BT NON connecté");
    }
};

#define LED 2
#define ON HIGH
#define OFF LOW

static const char *TAG = "sniffer";

#define OUI_VER 0x01355C6A

#define B_VERSION 0x01
#define B_IDENT_FR 0x02
#define B_IDENT_ANSI 0x03
#define B_CUR_LAT 0x04
#define B_CUR_LON 0x05
#define B_CUR_ALT 0x06
#define B_CUR_HAU 0x07
#define B_STA_LAT 0x08
#define B_STA_LON 0x09
#define B_CUR_VIT 0x0A
#define B_CUR_DIR 0x0B
#define B_CODE_INFO 0x0C


static const char* const WIFI_PHY_RATE[] =
{
  "1_Mbps_with_long_preamble",
  "2_Mbps_with_long_preamble",
  "5.5_Mbps_with_long_preamble",
  "11_Mbps_with_long_preamble",
  "",
  "2_Mbps_with_short_preamble",
  "5.5_Mbps_with_short_preamble",
  "11_Mbps_with_short_preamble",
  "48_Mbps",
  "24_Mbps",
  "12_Mbps",
  "6_Mbps",
  "54_Mbps",
  "36_Mbps",
  "18_Mbps",
  "9_Mbps",
  "MCS0_with_long_GI,_6.5_Mbps_for_20MHz,_13.5_Mbps_for_40MHz",
  "MCS1_with_long_GI,_13_Mbps_for_20MHz,_27_Mbps_for_40MHz",
  "MCS2_with_long_GI,_19.5_Mbps_for_20MHz,_40.5_Mbps_for_40MHz",
  "MCS3_with_long_GI,_26_Mbps_for_20MHz,_54_Mbps_for_40MHz",
  "MCS4_with_long_GI,_39_Mbps_for_20MHz,_81_Mbps_for_40MHz",
  "MCS5_with_long_GI,_52_Mbps_for_20MHz,_108_Mbps_for_40MHz",
  "MCS6_with_long_GI,_58.5_Mbps_for_20MHz,_121.5_Mbps_for_40MHz",
  "MCS7_with_long_GI,_65_Mbps_for_20MHz,_135_Mbps_for_40MHz",
  "MCS7_with_short_GI,_72.2_Mbps_for_20MHz,_150_Mbps_for_40MHz",
  "250_Kbps_LORA",
  "500_Kbps_LORA",
};

static const char* const WIFI_CBW[] =
{
  "20MHz",
  "40MHz",
};
//DEBUT SITE WEB

String trame = "";
//nom du point d'acces wifi
const char ssid[] = "DECODEUR_DGAC_XAV";
// Mot de pass du wifi
const char *password = "1234567890";
// wifi channel doit être 6
const int wifi_channel = 6;
//pour la puissance
int8_t P1;

WebServer MonServeurWeb(80);
BLECharacteristic * pCharacteristic;

//gestion du serveur web
String messageinit = "...";
String tramebrute = "";
String messageinfo = "";

String ID_Balise = "...";
String TRI_constructeur = "...";
String CODE_balise = "...";
String SN_balise = "...";
String LAT_home = "...";
String LON_home = "...";
String LAT_actu = "...";
String LON_actu = "...";
String HAU_actu = "...";
String ALT_actu = "...";
String VIT_actu = "...";
String DIR_actu = "...";
double codeinfo = 0;

String CouleurTexte = "red";
String CouleurMessage = "red";

String Wifi_RSSI = "...";
String Wifi_Canal = "...";
String Wifi_Rate = "...";
String Wifi_Bande = "...";

// calcul du temps depuis dernière capture trame
unsigned long agetrame = millis();

void handleRoot()
{
  // Page d'accueil
  String page = "<!DOCTYPE html>";
  page += "<head>";
  page += "    <title>Serveur " + String(ssid) + " </title>";
  page += "    <meta http-equiv='refresh' content='1' name='viewport' content='width=device-width, initial-scale=1' charset='UTF-8'/>";
  page += "</head>";
  page += "<body lang='fr'>";
  page += "    <h1 style='color:" + CouleurMessage + ";font-size:1.5vw;'>Récepteur: " + String(ssid) + " </h1>";
  page += "    <p style='color:blue;font-size:1vw;'> " + messageinit + " </p>";
  page += "    <hr>";
  page += "    <p style='color:blue;font-size:1.5vw;'>ID de la balise</p>";
  page += "    <p style='color:black;font-size:1vw;'>Trigramme constructeur: " + TRI_constructeur + " </p>";
  page += "    <p style='color:black;font-size:1vw;'>Code type de la balise: " + CODE_balise + " </p>";
  page += "    <p style='color:black;font-size:1vw;'>SN de la balise: " + SN_balise + " </p>";
  page += "    <hr>";
  page += "    <p style='color:blue;font-size:1.5vw;'>Position de départ</p>";
  page += "    <p style='color:black;font-size:1vw;'>Latitude de départ: " + LAT_home + " </p>";
  page += "    <p style='color:black;font-size:1vw;'>Longitude de départ: " + LON_home + " </p>";
  page += "    <hr>";
  page += "    <p style='color:blue;font-size:1.5vw;'>Dernière position connue</p>";
  page += "    <p style='color:black;font-size:1vw;'>Latitude: " + LAT_actu + " </p>";
  page += "    <p style='color:black;font-size:1vw;'>Longitude: " + LON_actu + " </p>";
  page += "    <p style='color:black;font-size:1vw;'>Altitude: " + ALT_actu + " </p>";
  page += "    <p style='color:black;font-size:1vw;'>Hauteur: " + HAU_actu + " </p>";
  page += "    <p style='color:black;font-size:1vw;'>Vitesse: " + VIT_actu + " </p>";
  page += "    <p style='color:black;font-size:1vw;'>Direction: " + DIR_actu + " </p>";
  page += "    <hr>";
  page += "    <p style='color:" + CouleurTexte + ";font-size:1vw;'> Dernière trame reçue depuis " + String((millis() - agetrame) / 1000) + " s.</p>";
  page += "    <hr>";
  page += "    <p style='color:blue;font-size:1.5vw;'>Message</p>";
  page += "    <p style='color:" + CouleurMessage + ";font-size:1vw;'> " + messageinfo + "</p>";
  page += "    <hr>";
  page += "    <p style='color:blue;font-size:1.5vw;'>Information Wifi balise</p>";
  page += "    <p style='color:black;font-size:1vw;'>RSSI: " + Wifi_RSSI + " </p>";
  page += "    <p style='color:black;font-size:1vw;'>Largeur de bande: " + Wifi_Bande + " </p>";
  page += "    <p style='color:black;font-size:1vw;'>Vitesse d'émission: " + Wifi_Rate + " </p>";
  page += "    <p style='color:black;font-size:1vw;'>Canal: " + Wifi_Canal + " </p>";
  page += "    <hr>";
  page += "    <p style='color:blue;font-size:1.5vw;'>Trame brute</p>";
  page += "    <p style='color:black;font-size:1vw;'> " + tramebrute + "</p>";
  page += "    <hr>";
  page += "</body>";
  page += "</html>";  // Fin page HTML

  MonServeurWeb.send(200, "text/html", page);  // Envoie de la page HTML
}

void handleNotFound()
{
  MonServeurWeb.send(404, "text/plain", "404: Not found");
}

boolean InitWeb()
{
  MonServeurWeb.on("/", HTTP_GET, handleRoot);  // Chargement de la page d'accueil
  MonServeurWeb.onNotFound(handleNotFound);  // Chargement de la page "Not found"
  MonServeurWeb.begin();  // Initialisation du serveur web
  return true;
}

// FIN SITE WEB

static void decoupeID_balise()
{
  //découpe l'id de la balise:
  TRI_constructeur = ID_Balise.substring(0, 3);
  CODE_balise = ID_Balise.substring(3, 6);
  SN_balise = ID_Balise.substring(6);
}


/** structure for Beacon Management Frame 802.11 + mandatory fields*/
typedef struct
{
  uint8_t subtype;              /**<  Frame subtype*/
  uint8_t type;               /**<  Frame typa*/
  uint16_t duration;              /**<  */
  uint8_t receiver_address[6];        /**<  Receiver mac-address*/
  uint8_t transmitter_address[6];       /**<  Transmitter mac-address*/
  uint8_t BSS_Id[6];              /**<  */
  uint16_t sequence_frag;           /**< 4 bits LSB frag, 12 bits MSB sequence sequence_frag = (0x000F & (frag)) | ( 0x0FFF & sequence<<4) */
  uint64_t timestamp;             /**<  Timestamp of frame*/
  uint16_t beacon_interval;         /** Interval between beacon frame */
  uint16_t capability;            /**mandatory fields */
  uint8_t ssid_element_id;          /** SSID Element ID */
  uint8_t ssid_length;            /** SSID length */
  uint8_t ssid_value[]; /** SSID value*/

} __attribute((__packed__)) frame_header_t;

typedef struct
{
  uint8_t type;       /**<  */
  uint8_t length;       /**<  */
  uint8_t payload[];      /**<  */
} __attribute((__packed__)) TLV_t;

static void initialize_nvs()
{
  esp_err_t err = nvs_flash_init();
  if (err == ESP_ERR_NVS_NO_FREE_PAGES || err == ESP_ERR_NVS_NEW_VERSION_FOUND) {
    ESP_ERROR_CHECK(nvs_flash_erase());
    err = nvs_flash_init();
  }
  ESP_ERROR_CHECK(err);
}

/* Initialize wifi with tcp/ip adapter */
static void initialize_wifi_sniffer()
{
  wifi_promiscuous_filter_t wifi_promiscuous_filter =
  {
    .filter_mask = WIFI_PROMIS_FILTER_MASK_MGMT
  };
  initialize_nvs();
  tcpip_adapter_init() ;
  ESP_ERROR_CHECK(esp_event_loop_create_default());
  wifi_init_config_t cfg = WIFI_INIT_CONFIG_DEFAULT();
  ESP_ERROR_CHECK(esp_wifi_init(&cfg));
  ESP_ERROR_CHECK(esp_wifi_set_storage(WIFI_STORAGE_RAM));
  ESP_ERROR_CHECK(esp_wifi_set_mode(WIFI_MODE_NULL));
  ESP_ERROR_CHECK( esp_wifi_start() );

  esp_wifi_set_promiscuous_filter(&wifi_promiscuous_filter);
  esp_wifi_set_promiscuous_rx_cb(wifi_sniffer_cb);
  ESP_ERROR_CHECK(esp_wifi_set_promiscuous(true));
  esp_wifi_set_channel(wifi_channel, WIFI_SECOND_CHAN_NONE);
  ESP_LOGI(TAG, "start WiFi promiscuous ok");
}

static void wifi_sniffer_cb(void *recv_buf, wifi_promiscuous_pkt_type_t type)
{

  static int32_t *oui_ver;
  static int32_t index, ptr, i;
  static int16_t i_value;
  static uint8_t *hex;
  static int8_t s_value;

  static wifi_promiscuous_pkt_t *sniffer;
  static TLV_t *tlv, *b_tlv;
  static vendor_ie_data_t *gse_vendor;
  static frame_header_t *packet;
  static float f_value;
  static char identifiant[31];

  sniffer = (wifi_promiscuous_pkt_t *)recv_buf;

  if ((*(uint16_t *)sniffer->payload) == 0x0080) //beacon frame
  {
    packet = (frame_header_t*) sniffer->payload;
    index = sizeof(*packet) + packet->ssid_length;
    while (index < (sniffer->rx_ctrl.sig_len - 4))
    {
      tlv = (TLV_t*)((sniffer->payload) + index);
      //WIFI_VENDOR_IE_ELEMENT_ID  ???
      if (tlv->type == 0xDD)
      {
        oui_ver = (int32_t*) tlv->payload;
        if ( *oui_ver == OUI_VER)
        {
          gse_vendor = (vendor_ie_data_t*)(tlv);
          ptr = 0;

          hex = (uint8_t*)sniffer->payload;
          for (i = 0; i < (sniffer->rx_ctrl.sig_len - 4); i++)
          {
            // Multiple of 16 means new line (with line offset).

            if ((i % 16) == 0) {
              // Don't print ASCII buffer for the "zeroth" line.
              if (i != 0)
                printf ("\r\n\t\t\t ");
            }

            // Now the hex code for the specific character.
            printf (" %02X", hex[i]);
          }
          printf("\",\r\n");

          while (ptr < (gse_vendor->length - 4))
          {
            b_tlv = (TLV_t*)((gse_vendor->payload) + ptr);
            switch (b_tlv->type)
            {
              case B_VERSION :
                //s_value = (uint8_t)(*(b_tlv->payload));
                //printf ("\t\t\"version\": \"%d\",\r\n", s_value);
                break;
              case B_IDENT_FR :
                memcpy (identifiant, b_tlv->payload, b_tlv->length);
                identifiant[b_tlv->length + 1] = '\0';
                //printf("\t\t\"ident fr\": \"%s\",\r\n", identifiant);
                // ID balise
                ID_Balise = String(identifiant);
                decoupeID_balise();
                break;
              case B_IDENT_ANSI :
                //memcpy (identifiant, b_tlv->payload, b_tlv->length);
                //identifiant[b_tlv->length + 1] = '\0';
                //printf("\t\t\"ident ansi\": \"%s\",\r\n", identifiant);
                break;
              case B_CUR_LAT :
                f_value = (float)((signed)(__bswap_32(*(int32_t*)(b_tlv->payload)))) / 100000.0;
                //printf("\t\t\"latitude actuelle\": \"%.5f\",\r\n", f_value);
                // Latitude
                LAT_actu = String(f_value, 5);
                break;
              case B_CUR_LON :
                f_value = (float)((signed)(__bswap_32(*(int32_t*)(b_tlv->payload)))) / 100000.0;
                //printf("\t\t\"longitude actuelle\": \"%.5f\",\r\n", f_value);
                // Longitude
                LON_actu = String(f_value, 5);
                break;
              case B_CUR_ALT :
                i_value = __bswap_16(*(int16_t*)(b_tlv->payload));
                //printf("\t\t\"altitude actuelle\": \"%d\",\r\n", i_value);
                // Altitude
                ALT_actu = String(i_value);
                break;
              case B_CUR_HAU :
                i_value = __bswap_16(*(int16_t*)(b_tlv->payload));
                //printf("\t\t\"hauteur relative actuelle\": \"%d\",\r\n", i_value);
                // hauteur
                HAU_actu = String(i_value);
                break;
              case B_STA_LAT :
                f_value = (float)((signed)(__bswap_32(*(int32_t*)(b_tlv->payload)))) / 100000.0;
                //printf("\t\t\"latitude depart\": \"%.5f\",\r\n", f_value);
                // home latitude
                LAT_home = String(f_value, 5);
                break;
              case B_STA_LON :
                f_value = (float)((signed)(__bswap_32(*(int32_t*)(b_tlv->payload)))) / 100000.0;
                //printf("\t\t\"longitude courante\": \"%.5f\",\r\n", f_value);
                // home longitude
                LON_home = String(f_value, 5);
                break;
              case B_CUR_VIT :
                s_value = *(b_tlv->payload);
                //printf("\t\t\"vitesse actuelle\": \"%d\",\r\n", s_value);
                //ground speed
                VIT_actu = String(s_value);
                break;
              case B_CUR_DIR :
                i_value = __bswap_16(*(int16_t*)(b_tlv->payload));
                //printf("\t\t\"cap actuel\": \"%d\"\r\n", i_value);
                //direction, cap
                DIR_actu = String(i_value);
                break;
              case B_CODE_INFO :
                //s_value = (uint8_t)(*(b_tlv->payload));
                //printf("\t\t\"code info\": \"%d\"\r\n", s_value);
                //CODEINFO
                codeinfo = (double)(*(b_tlv->payload));;
                break;
              default:
                //printf("b_tlv->type inconnu! : %0X\r\n", b_tlv->type);
                break;
            }
            ptr = ptr + (b_tlv->length) + 2;
          }
          //printf("\t\t}\r\n},\r\n");

          //préparation du message d'info pour le site web maintenant qu'on a stocké le code info dans la trame:
          //couleur rouge par défaut car plus de cas rouges...

          CouleurMessage = "red";
          int codetempo = (int)(codeinfo);
          switch (codetempo)
          {
            case 0:
              messageinfo = "Autre balise ou code info non trouvé...";
              break;
            case 1:
              messageinfo = "GPS non détecté, aucune donnée GPS reçue";
              break;
            case 2:
              messageinfo = "Positionnement du GPS non valide (fix en cours)";
              break;
            case 3:
              messageinfo = "Fix du GPS perdu...";
              break;
            case 4:
              messageinfo = "Le nombre de satellites captés est trop faible";
              break;
            case 5:
              messageinfo = "La précision GPS est trop faible";
              break;
            case 6:
              messageinfo = "L'altitude est indéfinie";
              break;
            case 7:
              messageinfo = "Stockage de la position de départ OK";
              CouleurMessage = "green";
              break;
            case 9:
              messageinfo = "Dernière trame reçue valide";
              //le seul cas où le message est vert
              CouleurMessage = "green";
              break;
            default:
              messageinfo = "cas non prévu!!!";
              break;
          }

          //infos wifi
          //on récup les infos wifi pour le site
          Wifi_RSSI = String(sniffer->rx_ctrl.rssi);
          Wifi_Bande = String(WIFI_CBW[sniffer->rx_ctrl.cwb]);
          Wifi_Rate = String(WIFI_PHY_RATE[sniffer->rx_ctrl.rate]);
          Wifi_Canal = String(sniffer->rx_ctrl.channel);

          //construire la trame dans l'ordre:
          trame = "ID=";
          trame += ID_Balise;
          trame += " lat=";
          trame += LAT_actu;
          trame += " long=";
          trame += LON_actu;
          trame += " alt=";
          trame += ALT_actu;
          trame += " hauteur=";
          trame += HAU_actu;
          trame += " lat_dep=";
          trame += LAT_home;
          trame += " long_dep=";
          trame += LON_home;
          trame += " Vitesse=";
          trame += VIT_actu;
          trame += " Dir=";
          trame += DIR_actu;
          trame += " CodeInfo=";
          trame += String(codetempo);
          //RSSI
          trame += " RSSI=";
          trame += String(Wifi_RSSI);
          //Largeur de bande
          trame += " Largeur=";
          trame += String(Wifi_Bande);
          //Vitesse
          trame += " Rate=";
          trame += String(Wifi_Rate);
          //Canal
          trame += " Canal=";
          trame += String(Wifi_Canal);

          // visu des infos wifi:
          Serial.print("RSSI="); Serial.println(Wifi_RSSI);
          Serial.print("Largeur="); Serial.println(Wifi_Bande);
          Serial.print("Rate="); Serial.println(Wifi_Rate);
          Serial.print("Canal="); Serial.println(Wifi_Canal);
          //visu de la trame
          Serial.println(trame);
          //c'est ici qu'on peut envoyer la trame au site web
          tramebrute = trame;
          //et au BT:
          pCharacteristic->setValue(trame.c_str());
          pCharacteristic->notify();
          //puis on la vide...
          trame = "";

          Serial.println("--------------------------");

          // ici réinit le compteur d'age
          agetrame = millis();
          CouleurTexte = "green";

          //selon codeinfo on fait varier la vitesse de la led:
          int compteur = 0;
          if (codetempo == 9)
          {
            //led bleue rythme rock'n'roll, tout est ok
            compteur = 8;
            while (compteur > 0)
            {
              digitalWrite(LED, ON);
              delay(25);
              digitalWrite(LED, OFF);
              delay(25);
              compteur--;
              digitalWrite(LED, ON);
            }
          }
          else
          {
            //led bleue rythme slow, souci
            compteur = 4;
            while (compteur > 0)
            {
              digitalWrite(LED, ON);
              delay(50);
              digitalWrite(LED, OFF);
              delay(50);
              compteur--;
              digitalWrite(LED, ON);
            }
          }
        } //if vendor ok
        else //sinon pas bonne trame
        {
          if (millis() > (agetrame + 6000))
          {
            Serial.print("plus de trame reçue depuis + de 6s: "); Serial.print((millis() - agetrame) / 1000); Serial.println(" s");
            CouleurTexte = "red";
            CouleurMessage = "red";
            digitalWrite(LED, OFF);
          }
          return;
        }
      }
      index = index + tlv->length + 2;
    }
  }
}

void setup()
{
  // initialize digital pin LED_BUILTIN as an output.
  pinMode(LED, OUTPUT);

  Serial.begin(115200);
  //led bleue démarrage
  int compteur = 4;
  while (compteur > 0)
  {
    digitalWrite(LED, ON);
    delay(250);
    digitalWrite(LED, OFF);
    delay(250);
    compteur--;
  }

  digitalWrite(LED, OFF);
  //initialisation du BLE
  BLEDevice::setMTU(256);
  esp_ble_tx_power_set(ESP_BLE_PWR_TYPE_ADV, ESP_PWR_LVL_P9); // ESP_PWR_LVL_N12       = 0 Corresponding to -12dbm 
                                                                 // ESP_PWR_LVL_N9        = 1 Corresponding to -9dbm
                                                                 // ESP_PWR_LVL_N6        = 2 Corresponding to -6dbm 
                                                                 // ESP_PWR_LVL_N3        = 3 Corresponding to -3dbm 
                                                                 // ESP_PWR_LVL_N0        = 4 Corresponding to 0dbm
                                                                 // ESP_PWR_LVL_P3        = 5 Corresponding to +3dbm <--- Default
                                                                 // ESP_PWR_LVL_P6        = 6 Corresponding to +6dbm 
                                                                 // ESP_PWR_LVL_P9        = 7 Corresponding to +9dbm
  BLEDevice::init("recepteur_DGAC");
  BLEServer *pServer = BLEDevice::createServer();
  pServer->setCallbacks(new MyServerCallbacks());
  BLEService *pService = pServer->createService(SERVICE_UUID);
  pCharacteristic = pService->createCharacteristic(
                      CHARACTERISTIC_UUID,
                      BLECharacteristic::PROPERTY_READ |
                      BLECharacteristic::PROPERTY_WRITE
                    );
  pService->start();
  // BLEAdvertising *pAdvertising = pServer->getAdvertising();  // this still is working for backward compatibility
  BLEAdvertising *pAdvertising = BLEDevice::getAdvertising();
  pAdvertising->addServiceUUID(SERVICE_UUID);
  pAdvertising->setScanResponse(true);
  pAdvertising->setMinPreferred(0x06);  // functions that help with iPhone connections issue
  pAdvertising->setMinPreferred(0x12);
  BLEDevice::startAdvertising();

  //init wifi
  Serial.println("--------------------------");
  Serial.println("Mise en place du wifi:");
  //messageinit = ("Mise en place du wifi en cours...");messageinit+="<br>";
  // init du sniffer wifi sur channel 6
  initialize_wifi_sniffer();

  //démarrage wifi AP pour site web
  WiFi.mode(WIFI_AP);
  //infos sur le wifi:
  if (WiFi.softAP(ssid, password, wifi_channel, false) == false) // ssid, pwd, channel, hidden (facultatif), max_cnx (facultatif, de 0 à 8, 4 par défaut)
  {
    Serial.print("ECHEC de mise en place du wifi, dont le nom est: "); Serial.println(ssid);
    return;
  }
  //infos sur le wifi:
  Serial.print("Nom du récepteur: "); Serial.println(ssid);
  //attente init correcte du wifi:
  delay(500);
  //messageinit = ("Mise en place du wifi Ok");messageinit+="<br>";

  // autres paramétrages, adresse ip fixée pour avoir toujours la même:
  IPAddress Ip(192, 168, 1, 1);
  IPAddress NMask(255, 255, 255, 0);
  WiFi.softAPConfig(Ip, Ip, NMask);

  //affichage des infos
  IPAddress myIP = WiFi.softAPIP();
  Serial.print("Adresse IP du récepteur: ");
  Serial.println(myIP.toString());
  //messageinit += ("Adresse IP du récepteur: ");messageinit += myIP.toString();messageinit+="<br>";
  Serial.print("Adresse MAC du récepteur: ");
  Serial.println(WiFi.macAddress());
  messageinit = ("Adresse MAC: "); messageinit += WiFi.macAddress(); messageinit += "<br>";
  // vérifier de la puissance d'émission
  esp_err_t r = esp_wifi_get_max_tx_power(&P1);
  Serial.print("Puissance de transmission (dBm): "); Serial.println(P1 * 0.25);
  Serial.println("--------------------------");

  // démarrage du serveur web
  if (!InitWeb())
  {
    Serial.println("Erreur démarrage site web");
    digitalWrite(LED, OFF);
  }
  else
  {
    Serial.print("Serveur web récepteur actif sur http://"); Serial.print(myIP); Serial.println("/");
  }
  Serial.println("--------------------------");
  Serial.println("En attente de trames...");
}
void loop()
{
  //app_main();
  //gestion serveur web
  MonServeurWeb.handleClient();  // Attente de demande du client
  //digitalWrite(LED, OFF);

//  if (deviceConnected) 
//  {
//    //Serial.println("BT connecté");
//  }
//  else
//  {
//    //Serial.println("BT NON connecté");
//  }
}
